VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "COM_port"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'                 COM-
'------------------------------------------------------------
'          
'   (COM-) Visual Basic 6.0
' :
'  ,   ,    
'   (  GENERAL),   :
'   Private  As New COM_port
' "" -    .
'
'        :
'
'  
'
'   .OpenCOM
'
' ()  -   :  .
'         
'  (    ).
'   9600.
',  ,   , , .
'  ,    8,N,1.
'   ,   True.
'  ,   False,    
'.
'
'   
'        
' .   
'   Form_Unload:
'
'       .ClosePort
'
'      .    
'  ,     .
'
'       .ListPorts -   COM-,
'  .  .
' -    .
'   .ListPorts(0)  
',     .
' .ListPorts(0)=0,  COM-   .
'
'
'  .
'      
'  .
'   .WritePort -      
'  .  -  .
'   .WritePortWait -   ,  
' .
'
'  .
'   .ReadPort -   . 
'   ,   .
'   ,      .
'   .WaitReadPort -  
'.    ,   
' ,     .
'   .LineReadPort - ,  
'  (CrLf)     .
'  ,    
' ,  CrLf    .  
'      
' .
'    ,    
' .
'
'      .InBytes -   
'  .  .
'
' .
'      .WaitData = True
'    , 
' ,      -.
'      .
'   .     ,
'  WaitData  False.
'   .
'
'   .PurgeData -     .
'      .
'
'   .Tag -   Variant.  
'  .    .
'
'   .hPort - .  .
'  ;  ,  .
'
' .
'    
'   .LastError
'  , LastError   .
'
'       
'   :
'   _ReadFault(ErrMsg As String)  -  
'   _WriteFault(ErrMsg As String) -  
'   _DataReady() -     WaitData.
'
'------------------------------------------------------------
'

Option Explicit

Private BarDCB As DCB '  
Private CtimeOut As COMMTIMEOUTS ' 
Private bRead(2047) As Byte '  

'    
Private Type COMMTIMEOUTS
        ReadIntervalTimeout As Long
        ReadTotalTimeoutMultiplier As Long
        ReadTotalTimeoutConstant As Long
        WriteTotalTimeoutMultiplier As Long
        WriteTotalTimeoutConstant As Long
End Type
Private Type DCB
        DCBlength As Long
        BaudRate As Long
        fBitFields As Long
        wReserved As Integer
        XonLim As Integer
        XoffLim As Integer
        ByteSize As Byte
        Parity As Byte
        StopBits As Byte
        XonChar As Byte
        XoffChar As Byte
        ErrorChar As Byte
        EofChar As Byte
        EvtChar As Byte
        wReserved1 As Integer
End Type

'       (  ClearCommError)
Private Type COMSTAT
        fBitFields As Long
        cbInQue As Long '   
        cbOutQue As Long
End Type

'    -
Private Type OVERLAPPED
        Internal As Long
        InternalHigh As Long
        offset As Long
        OffsetHigh As Long
        hEvent As Long
End Type

'  API
Private Declare Function CreateFile Lib "kernel32" Alias "CreateFileA" (ByVal lpFileName As String, ByVal dwDesiredAccess As Long, ByVal dwShareMode As Long, ByVal lpSecurityAttributes As Long, ByVal dwCreationDisposition As Long, ByVal dwFlagsAndAttributes As Long, ByVal hTemplateFile As Long) As Long
Private Declare Function PurgeComm Lib "kernel32" (ByVal hFile As Long, ByVal dwFlags As Long) As Long
Private Declare Function SetCommTimeouts Lib "kernel32" (ByVal hFile As Long, lpCommTimeouts As COMMTIMEOUTS) As Long
Private Declare Function SetCommState Lib "kernel32" (ByVal hCommDev As Long, lpDCB As DCB) As Long
Private Declare Function ReadFile Lib "kernel32" (ByVal hFile As Long, lpBuffer As Any, ByVal nNumberOfBytesToRead As Long, lpNumberOfBytesRead As Long, lpOverlapped As OVERLAPPED) As Long
Private Declare Function WriteFile Lib "kernel32" (ByVal hFile As Long, lpBuffer As Any, ByVal nNumberOfBytesToWrite As Long, lpNumberOfBytesWritten As Long, lpOverlapped As OVERLAPPED) As Long
Private Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
Private Declare Function GetLastError Lib "kernel32" () As Long
Private Declare Function ClearCommError Lib "kernel32" (ByVal hFile As Long, lpErrors As Long, lpStat As COMSTAT) As Long
Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)
Private Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, ByVal samDesired As Long, phkResult As Long) As Long
Private Declare Function RegEnumValue Lib "advapi32.dll" Alias "RegEnumValueA" (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpValueName As String, lpcbValueName As Long, ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Long) As Long
Private Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long

'   
Private mvarhPort As Long '  
Public LastError As String
Public Tag As Variant
Public Event ReadFault(ErrMsg As String)
Public Event WriteFault(ErrMsg As String)
Public Event DataReady()
Private mvarWaitData As Boolean
Private presWaitData As Boolean

Public Property Get hPort() As Long
'   ( )
    hPort = mvarhPort
End Property

Public Property Get InBytes() As Long
'      ( ).
    Dim retval As Long
    Dim CommStat As COMSTAT
    Sleep 1
    retval = ClearCommError(mvarhPort, retval, CommStat)
    InBytes = CommStat.cbInQue
    If CommStat.cbInQue < 0 Then InBytes = 0
    LastError = ""
End Property

Public Property Get ListPorts() As Variant
'   
'   ,    ( ).
'ListPorts(0)   ,
'  -  .
'     .
    Dim hKey As Long, lRet As Long, sValueName As String
    Dim lValueNameLen As Long, lValueType As Long
    Dim sData As String, lDataLen As Long
    Dim i As Long, j As Long
    Dim COMList() As Integer
    ReDim COMList(0)
    COMList(0) = 0
    
    '   HKEY_LOCAL_MACHINE  
    lRet = RegOpenKeyEx(&H80000002, "HARDWARE\DEVICEMAP\SERIALCOMM", 0, &H20019, hKey)
    If lRet = 0 Then
      '    
      i = 0: j = 0
      Do
          lValueNameLen = 255: sValueName = Space$(lValueNameLen)
          lDataLen = 255: sData = Space$(lDataLen)
          lRet = RegEnumValue(hKey, i, sValueName, lValueNameLen, 0, lValueType, ByVal sData, lDataLen)
          If lRet = 0 Then
            i = i + 1
            If lDataLen > 3 Then
              If UCase$(Left$(sData, 3)) = "COM" Then
                sData = Left$(sData, (lDataLen - 1))
                lRet = Val(Right$(sData, (Len(sData) - 3)))
                If lRet > 0 Then
                  j = j + 1
                  ReDim Preserve COMList(j)
                  COMList(0) = j
                  COMList(j) = lRet
                End If
              End If
            End If
          Else
            Exit Do
          End If
      Loop
      RegCloseKey hKey
      If COMList(0) > 1 Then
        i = 2: j = 2
        While i <= COMList(0)
          If COMList(i - 1) < COMList(i) Then
            i = j: j = j + 1
          Else
            lRet = COMList(i - 1)
            COMList(i - 1) = COMList(i)
            COMList(i) = lRet
            i = i - 1
            If i = 1 Then
              i = j: j = j + 1
            End If
          End If
        Wend
      End If
    End If
    ListPorts = COMList
    LastError = ""
End Property

Public Property Let WaitData(ByVal vData As Boolean)
'    ,
'  WaitData = True
'     CheckBox.
    Dim retval As Long
    Dim CommStat As COMSTAT
    If (mvarWaitData <> vData) Then
      mvarWaitData = vData
      If presWaitData = False Then
        presWaitData = True
        Do '   
          Sleep 1 '  
          retval = ClearCommError(mvarhPort, retval, CommStat)
          If CommStat.cbInQue <> 0 Then
            mvarWaitData = False
            RaiseEvent DataReady
          End If
          DoEvents
        Loop Until mvarWaitData = False
        presWaitData = False
      End If
    End If
End Property
Public Property Get WaitData() As Boolean
    WaitData = mvarWaitData
End Property


Public Function OpenCOM(ByVal PortNumber As Long, Optional ByVal baud As Long = 9600, Optional ByVal bits As Byte = 8, Optional ByVal Parity As String = "n", Optional ByVal stops As Single = 1) As Boolean
'    COM-.
'  - ,  :  COM-
'  -   (   ).
'  ,   9600.
'   : , , .
'    8,N,1.
'     True,    ,
' False       LastError.
'      ,
' ,   .
'
    Dim retval As Long, COMname$
    OpenCOM = False
    COMname$ = "COM" + Trim(Str$(PortNumber))
    If PortNumber > 9 Then COMname$ = "\\.\" + COMname$
    
    If mvarhPort > 0 Then retval = CloseHandle(mvarhPort) '    - .
    mvarhPort = CreateFile(COMname$, &HC0000000, 0, 0&, &H3, 0, 0)
    If mvarhPort = -1 Then
        LastError = "  "
        Exit Function
    End If
    LastError = ""
    retval = PurgeComm(mvarhPort, 15) ' , 
    
    '     
    BarDCB.DCBlength = 28  '  DCB
    BarDCB.BaudRate = baud  '   
    BarDCB.fBitFields = &H83 ' ,    :
            '1 fBinary   .  1 ( Windows 3.x :))
            '2 fParity          1 - ,   .
            '3 fOutxCtsFlow     1 -  CTS:   CTS     CTS.
            '4 OutxDsrFlow      1 -     DSR
            '5,6 fDtrControl      DTR.  ,  , .
            '7 fDsrSensitivity     DSR.  1     ,   DSR.
            '8 fTXContinueOnXoff 0 -      Xoff   Xon.
            '9 fOutX            1 -     Xoff   Xon.
            '10 fInX            1 -     Xon\Xoff
            '11 fErrorChar      1 -           ErrorChar
            '12 fNull           1 -    
            '13,14 fRtsControl  0 -  RTS.       ,   -  .
            '15 fAbortOnError   1 -        ClearCommError.
            '16 fDummy2         =0 ,  .
    BarDCB.wReserved = 0 ' ,   0
    BarDCB.XonLim = 128 '          XON
    BarDCB.XoffLim = 64 '  -        XOFF.          ( )
    BarDCB.ByteSize = 8      '  (- )
    BarDCB.Parity = 0      '1- , 2- , 0-  
    BarDCB.StopBits = 0     '  : 0 -, 1 -, 2 -
    BarDCB.XonChar = 17 ',    Xon
    BarDCB.XoffChar = 19 ',    Xoff
    BarDCB.ErrorChar = 35 ',    
    BarDCB.EofChar = 26 ' " "
    BarDCB.EvtChar = 0  '    
    BarDCB.wReserved1 = 0 '.  .

    '  (Time Outs)  
    CtimeOut.ReadIntervalTimeout = 1 '     .
    CtimeOut.ReadTotalTimeoutConstant = 1 '    
    CtimeOut.ReadTotalTimeoutMultiplier = 1 '     (    )
    CtimeOut.WriteTotalTimeoutConstant = 20 '    
    CtimeOut.WriteTotalTimeoutMultiplier = 5 '     (    )
                                                         '  ,    .
    If Len(LTrim(Parity)) > 0 Then
      If Asc(LCase$(LTrim(Parity))) = 111 Then BarDCB.Parity = 1 'o
      If Asc(LCase$(LTrim(Parity))) = 101 Then BarDCB.Parity = 2 'e
    End If
    If stops > 1 Then BarDCB.StopBits = 1
    If stops >= 2 Then BarDCB.StopBits = 2
    
    ' 
 '   CtimeOut.ReadIntervalTimeout = 1 + Int(12000 / baud)
 '   CtimeOut.ReadTotalTimeoutConstant = 1
 '   CtimeOut.ReadTotalTimeoutMultiplier = 1 + Int(12000 / baud)
    CtimeOut.WriteTotalTimeoutMultiplier = 1 + Int(12000 / baud)
    retval = SetCommTimeouts(mvarhPort, CtimeOut)
    If retval = -1 Then
        retval = GetLastError()
        LastError = "   , Error: " & retval
    End If
    retval = SetCommState(mvarhPort, BarDCB)
    If retval = -1 Then
        retval = GetLastError()
        LastError = LastError & "        Error: " & retval
    End If
    If LastError <> "" Then
      If mvarhPort > 0 Then retval = CloseHandle(mvarhPort)
      mvarhPort = -1
      Exit Function
    End If
    OpenCOM = True '  
End Function

Public Function LineReadPort(ByVal TimeoutSec As Integer) As String
'  COM     
'  (CrLf).
'  ,  CrLf.
'       
'  ,   
'  ,   .

    Dim recChars As String, readChar As String, t As Long
    recChars = ""
    t = TimeoutSec * 1000
    Do
      readChar = ReadPort(1)
      If readChar = "" Then
        t = t - 50
        Sleep 50
        DoEvents
      Else
        t = TimeoutSec * 1000
        If t < 1 Then t = 1
        recChars = recChars + readChar
        If Right$("  " + recChars, 2) = vbCrLf Then t = 0
      End If
      If LastError <> "" Then t = 0
    Loop Until t < 1
    LineReadPort = recChars
End Function

Public Function ReadPort(Optional ByVal chrQuantity As Integer) As String
'   COM
' -     ,  2047
'  ,       .
    Dim RetBytes As Long, i As Integer, ReadStr As String, retval As Long, numChar As Integer
    Dim CommStat As COMSTAT
    Dim lpOverlapped As OVERLAPPED

    LastError = ""
    ReadPort = ""

    If chrQuantity = 0 Then
      retval = ClearCommError(mvarhPort, retval, CommStat)
      If retval = 0 Then
        retval = GetLastError()
        LastError = "      Error: " & retval
        RaiseEvent ReadFault(LastError)
        Exit Function
      End If
      numChar = CommStat.cbInQue
    Else
      numChar = chrQuantity
    End If
    If numChar < 1 Then Exit Function

    '  
    retval = ReadFile(mvarhPort, bRead(0), numChar, RetBytes, lpOverlapped)
    If retval = 0 Then
        retval = GetLastError()
        LastError = "    Error: " & retval
        RaiseEvent ReadFault(LastError)
    End If

    ReadStr = ""
    If (RetBytes > 0) Then
        For i = 0 To RetBytes - 1
            ReadStr = ReadStr + Chr(bRead(i))
        Next i
    End If

    ReadPort = ReadStr
End Function

Public Function WaitReadPort(ByVal chrQuantity As Integer) As String
'  COM    ( 2047).
'   ,    
'   .

    LastError = ""
    WaitReadPort = ""
    If chrQuantity < 1 Then Exit Function
    If BarDCB.BaudRate = 0 Then
      LastError = "    : BaudRate=0"
      RaiseEvent ReadFault(LastError)
      Exit Function
    End If
    Sleep (CLng((12000 / BarDCB.BaudRate) * chrQuantity) + 1)
    WaitReadPort = ReadPort(chrQuantity)
End Function

Public Sub WritePort(ByVal DataSend As String)
'      COM-.

    Dim RetBytes As Long, LenVal As Long, retval As Long
    Dim CommStat As COMSTAT
    Dim lpOverlapped As OVERLAPPED

    LastError = ""
    If DataSend = "" Then Exit Sub

    ' :   
    '  2048  (   - 2048 )
    If Len(DataSend) > 2047 Then
        Call WritePort(Left$(DataSend, 2047))
        If LastError <> "" Then Exit Sub
        Do ',     
          Sleep 1
          DoEvents
          retval = ClearCommError(mvarhPort, retval, CommStat)
        Loop Until CommStat.cbOutQue = 0
        retval = Len(DataSend)
        If retval > 2047 Then retval = retval - 2047
        Call WritePort(Right$(DataSend, retval))
        Exit Sub
    End If

    '   
    For LenVal = 0 To Len(DataSend) - 1
        bRead(LenVal) = Asc(Mid$(DataSend, LenVal + 1, 1))
    Next LenVal

    'a  COM
    retval = WriteFile(mvarhPort, bRead(0), Len(DataSend), RetBytes, lpOverlapped)
    If retval = 0 Then
        retval = GetLastError()
        LastError = "  Error: " & retval & "    " & RetBytes & " "
        RaiseEvent WriteFault(LastError)
    End If
End Sub

Public Sub WritePortWait(ByVal DataSend As String)
'    COM-
' ,      .
    Dim retval As Long
    Dim CommStat As COMSTAT
    Call WritePort(DataSend)
    If LastError <> "" Then Exit Sub
    Do      ',     
      Sleep 1
      retval = ClearCommError(mvarhPort, retval, CommStat)
    Loop Until CommStat.cbOutQue < 1
End Sub

Public Sub PurgeData()
'  
    Dim retval As Long
    retval = PurgeComm(mvarhPort, 15)
    LastError = ""
End Sub

Public Sub ClosePort()
'  ,   
    Dim retval As Long
    If mvarhPort > 0 Then retval = CloseHandle(mvarhPort)
    mvarhPort = 0
    mvarWaitData = False '  
    LastError = ""
End Sub
